//+------------------------------------------------------------------+
//|                                                 LabTrend2_v2.mq4 |
//|                                  Copyright  2007, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Chartreuse
#property indicator_color2 Orange






extern int    Risk        = 3;         // Sensivity Factor
extern double MoneyRisk   = 2.00;     // Offset Factor
extern int    FastLength  = 9;
extern int    SlowLength  = 50; 
extern int    Phase       = 0;
extern int    Price       = 0;






double UpTrendBuffer[];
double DownTrendBuffer[];
double smax[];
double smin[];
double trend[];







  int init()
  {
   
   IndicatorBuffers(5);
   SetIndexBuffer(0,UpTrendBuffer);  SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159); SetIndexLabel(0,"UpTrend Stop");
   SetIndexBuffer(1,DownTrendBuffer);SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159); SetIndexLabel(1,"DownTrend Stop");
   SetIndexBuffer(2,smin);
   SetIndexBuffer(3,smax);
   SetIndexBuffer(4,trend);
   
   IndicatorShortName("LabTrend2");
   

   return(0);
  }
  
  
int deinit() { return(0); }






int start()
  {
  
   double delta= 1; 
   int    counted_bars=IndicatorCounted();
   int    i,j,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit = MathMin(Bars-counted_bars,Bars-1);
   
   
   for(i=limit; i>=0; i--)
   {
     double Range=iATR(NULL,0,10,i);
     double AvgRange=iATR(NULL,0,100,i);
     if (Range<AvgRange) Range=AvgRange;
     
     smax[i]= High[i]+(1.5+0.1*Risk)*Range;
	  smin[i]= Low[i] -(1.5+0.1*Risk)*Range;
	  
	  double sma1=iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),FastLength,Phase,i, 0);
	  double sma2=iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),SlowLength,Phase,i,10);
	  
	  trend[i]=trend[i+1];  
	  if (sma1-sma2>delta*Point) trend[i]=1; 
	  if (sma2-sma1>delta*Point) trend[i]=-1;
		 	
	  if(trend[i]>0)
	  {
	  if(Low[i]-smin[i]<MoneyRisk*Range) smin[i]=Low[i]-MoneyRisk*Range;
	  if(smin[i]<smin[i+1]) smin[i]=smin[i+1];
	  }
	  
	  if(trend[i]<0)
	  {
	  if(smax[i]-High[i]<MoneyRisk*Range) smax[i]=High[i]+MoneyRisk*Range;
	  if(smax[i]>smax[i+1]) smax[i]=smax[i+1];
	  }	  
	  	    
	  if (trend[i]>0) 
	  {
	     if (trend[i+1]<0)
	     {
	     smin[i]=Low[i]-Range;
	     UpTrendBuffer[i]=smin[i];
	     }
	     else
	     {
	     UpTrendBuffer[i]=smin[i];
	     }
	     DownTrendBuffer[i]=EMPTY_VALUE;
	     }
	  if (trend[i]<0) 
	  {
	     if (trend[i+1]>0)
	     {
	     smax[i]=High[i]+Range;
	     DownTrendBuffer[i]=smax[i];
	     }
	     else
	     {
	     DownTrendBuffer[i]=smax[i];
	     }
	     UpTrendBuffer[i]=EMPTY_VALUE;
	     }
	  
	   }
	return(0);	
 }
 
    
double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

  
double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}